Index: trunk/kernel/libk/remote_barrier.h
===================================================================
--- trunk/kernel/libk/remote_barrier.h	(revision 690)
+++ trunk/kernel/libk/remote_barrier.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
- * remote_barrier.h - POSIX barrier definition.               
+ * remote_barrier.h - distributed kernel barrier definition
  * 
- * Author  Alain Greiner (2016,2017,2018,2019)
+ * Author  Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -10,5 +10,5 @@
  * ALMOS-MKH is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; version 2.0 of the License.
+err* the Free Software Foundation; version 2.0 of the License.
  *
  * ALMOS-MKH is distributed in the hope that it will be useful, but
@@ -25,285 +25,34 @@
 #define _REMOTE_BARRIER_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <remote_busylock.h>
-#include <xlist.h>
-#include <shared_pthread.h>
+#include <almos_config.h>
+#include <hal_types.h>
 
-/***************************************************************************************
- *       This file defines two implementations for a POSIX compliant barrier.
- *
- * It is used by multi-threaded user applications to synchronise threads running in
- * different clusters. Access functions use RPCs for barrier creation/destruction,
- * and use remote access primitives for actual synchronisation (wait function).
- *
- * A barrier is declared by a given user process as a "pthread_barrier_t" user variable.
- * This user type is implemented in user space as an unsigned long, but the value is not
- * used by the kernel. ALMOS-MKH uses only the barrier virtual address as an identifier.
- * For each user barrier, ALMOS-MKH creates a kernel structure, dynamically allocated 
- * by the generic_barrier_create() function, destroyed by the generic_barrier_destroy()
- * function, and used by the generic_barrier_wait() function.
- *
- * Implementation note:
- * ALMOS-MKH supports two barrier implementations:
- *
- * 1) simple_barrier_t
- *    If the pointer on the barrier attributes is NULL, the barrier is implemented as
- *    a shared variable localized in the reference process cluster. 
- *    There is a risk of contention when the number of synchronizing threads is large.
- *
- * 2) dqt_barrier_t
- *    If the (x_size, y_size, nthreads) arguments are defined in the barrier attributes,
- *    the barrier is implemented as a hierarchical quad-tree covering all clusters in the
- *    (x_size * ysize) mesh, including cluster (0,0), with nthreads per cluster.
- *    This DQT (Distributed Quad Tree) implementation assumes a regular architecture, 
- *    and a strong contraint on the threads placement: exactly "nthreads" threads per 
- *    cluster in the (x_size * y_size) mesh.
- *
- * For both implementations, the blocking "generic_barrier_wait()" function implements
- * a descheduling policy when the calling thread is not the last expected thread: 
- * the calling thread is registered in a waiting queue, rooted in the barrier structure, 
- * and the the calling thread is blocked on the THREAD_BLOCKED_USERSYNC condition. 
- * The last arrived thread unblocks all registered waiting threads.
- * **************************************************************************************/
+/*****************************************************************************************
+ * This structure defines a distributed "rendez-vous" barrier, that can be used
+ * to synchronise several kernel threads running in different clusters
+ * It is used in the parallel kernel_init phase.
+ * It does not need to be initialised, but it must be statically allocated 
+ * in the KDATA segment to be properly initialised by the compiler/loader.
+ ****************************************************************************************/
+
+typedef struct remote_barrier_s
+{
+    uint32_t   current;   // number of arrived threads
+    uint32_t   sense;     // barrier state (toggle)
+    uint32_t   pad[(CONFIG_CACHE_LINE_SIZE>>2)-2];
+} 
+remote_barrier_t;
+
+/*****************************************************************************************
+ * This blocking function implements a toggle barrier. It returns only when all
+ * expected threads reach the barrier. It can be used several times without
+ * specific initialisation. 
+ * It is portable, as it uses the remote_lw() & remote_sw() access functions.
+ * @ xp      : extended pointer on barrier in remote cluster
+ * @ count   : number of expected thread
+ ****************************************************************************************/
+inline void remote_barrier( xptr_t   xp,  
+                            uint32_t count );
 
 
-
-/*****************************************************************************************
- *                 generic barrier descriptor and access functions
- *****************************************************************************************
- * This generic structure is used by both the simple and the QOT implementations.
- * It is implemented in the reference process cluster, and contains
- * - the barrier identifier,
- * - the implementation type (simple or dqt),
- * - an xlist implementing the set of barriers dynamically created by a given process,
- * - a pointer on the implementation specific descriptor (simple_barrier / sqt_barrier).
- ****************************************************************************************/
-
-typedef struct generic_barrier_s
-{
-    intptr_t              ident;      /*! virtual address in user space == identifier   */
-    xlist_entry_t         list;       /*! member of list of barriers in same process    */
-    bool_t                is_dqt;     /*! DQT implementation when true                  */
-    void                * extend;     /*! implementation specific barrier descriptor    */
-} 
-generic_barrier_t;
-
-/*****************************************************************************************
- * This function returns an extended pointer on the remote barrier identified
- * by its virtual address in a given user process. It makes an associative search, 
- * scanning the list of barriers rooted in the reference process descriptor.
- * It can be used for both simple and DQT barriers, registered in the same list.
- *****************************************************************************************
- * @ ident    : barrier virtual address, used as identifier.
- * @ returns extended pointer on barrier if success / returns XPTR_NULL if not found. 
- ****************************************************************************************/
-xptr_t generic_barrier_from_ident( intptr_t  ident );
-
-/*****************************************************************************************
- * This function implements the pthread_barrier_init() syscall.
- * It allocates and initialises the generic barrier descriptor in the reference process 
- * cluster, and - depending on the <attr> argument, calls the relevant (simple or DQT) 
- * function to allocate and initialize the implementation dependant barrier descriptor.
- * Finally, it registers the barrier in the reference process xlist of user barriers.
- * It can be called by a thread running in any cluster, as it use RPC if required.
- *****************************************************************************************
- * @ ident    : barrier virtual address, used as identifier.
- * @ count    : number of expected threads.
- * @ attr     : barrier attributes (x_size,y_size,nthreads), used by QDT implementation.
- * @ returns 0 if success / returns -1 if not found. 
- ****************************************************************************************/
-error_t generic_barrier_create( intptr_t                ident,
-                                uint32_t                count,
-                                pthread_barrierattr_t * attr );
-
-/*****************************************************************************************
- * This function implements the pthread_barrier_destroy() syscall.
- * It calls the relevant function (simple or DQT) to release the memory allocated for 
- * the implementation specific barrier descriptor, and releases the memory allocated
- * for the generic barrier descriptor.
- * It removes the barrier from the list of barriers rooted in the reference process.
- * It can be called by a thread running in any cluster, as it use RPC if required.
- *****************************************************************************************
- * @ gen_barrier_xp  : extended pointer on generic barrier descriptor.
- ****************************************************************************************/
-void generic_barrier_destroy( xptr_t gen_barrier_xp );
-
-/*****************************************************************************************
- * This blocking function implements the pthread_barrier_wait() syscall.
- * It calls the relevant function (simple or DQT) depending on the implementation,
- * and returns only when all expected threads reach the barrier.
- * It can be called by a thread running in any cluster, as it use remote accesses.
- *****************************************************************************************
- * @ gen_barrier_xp   : extended pointer on generic barrier descriptor.
- ****************************************************************************************/
-void generic_barrier_wait( xptr_t gen_barrier_xp );
-
-
-/*****************************************************************************************
- * This debug function uses remote accesses to display the current state of a generic
- * barrier identified by the <gen_barrier_xp> argument. 
- * It calls the relevant function (simple or DQT) to display relevant information.
- * It can be called by a thread running in any cluster.
- *****************************************************************************************
- * @ barrier_xp   : extended pointer on generic barrier descriptor.
- ****************************************************************************************/
-
-void generic_barrier_display( xptr_t gen_barrier_xp );
-
-
-
-/*****************************************************************************************
- *                        simple barrier descriptor
- *****************************************************************************************
- * This structure defines the simple barrier descriptor. It is localized in the process
- * reference cluster, as an extension of the generic barrier descriptor.
- * It implements a toggle barrier remotely accessed by all threads.
- * It contains the root of the xlist registering all arrived threads.
- ****************************************************************************************/
-
-typedef struct simple_barrier_s
-{
-    remote_busylock_t  lock;          /*! lock protecting list of waiting threads       */
-    uint32_t           current;       /*! number of arrived threads                     */
-    uint32_t           sense;         /*! barrier state (toggle)                        */
-    uint32_t           arity;         /*! number of expected threads                    */ 
-    xlist_entry_t      root;          /*! root of list of waiting threads               */
-} 
-simple_barrier_t;
-
-/*****************************************************************************************
- * This function allocates memory for the simple barrier descriptor in the reference 
- * cluster of the calling process. It initializes the barrier state and returns
- * a local pointer on the created simple barrier descriptor in reference cluster.
- * It can be called by a thread running in any cluster, as it use RPC if required.
- *****************************************************************************************
- * @ count          : [in] number of expected threads.
- * @ return Local pointer on barrier descriptor if success / return NULL if failure.
- ****************************************************************************************/
-simple_barrier_t * simple_barrier_create( uint32_t  count );
-
-/*****************************************************************************************
- * This function releases the memory allocated for the simple barrier descriptor. 
- * It can be called by a thread running in any cluster, as it use RPC if required.
- *****************************************************************************************
- * @ barrier_xp  : extended pointer on simple barrier descriptor.
- ****************************************************************************************/
-void simple_barrier_destroy( xptr_t   barrier_xp );
-
-/*****************************************************************************************
- * This blocking function returns only when all expected threads reach the barrier.
- * It can be called by a thread running in any cluster, as it use remote accesses.
- * Waiting threads use a descheduling policy.
- *****************************************************************************************
- * @ barrier_xp   : extended pointer on simple barrier descriptor.
- ****************************************************************************************/
-void simple_barrier_wait( xptr_t   barrier_xp );
-
-/*****************************************************************************************
- * This debug function uses remote accesses to display the current state of a simple
- * barrier identified by the <barrier_xp> argument.
- * It can be called by a thread running in any cluster.
- *****************************************************************************************
- * @ barrier_xp   : extended pointer on simple barrier descriptor.
- ****************************************************************************************/
-void simple_barrier_display( xptr_t barrier_xp );
-
-
-
-
-/*****************************************************************************************
- *                              dqt_barrier
- *****************************************************************************************
- * These structuree define  the hierarchical DQT barrier, physically distributed in a
- * mesh of clusters defined by the (x_size, y_size, nthreads) arguments:
- *   . The involved clusters form a mesh [x_size * y_size]
- *   . The lower left involved cluster is cluster(0,0)  
- *   . The number of threads per cluster is the same in all clusters.
- *
- * Implementation note:
- * - The quad three is implemented as a three dimensions array of node[x][y][l]
- *   . [x][y] are the cluster coordinates / max values are (DQT_XMAX-1), (DQT_YMAX-1)
- *   . [l] is the node level / 0 for terminal nodes / (DQT_LMAX-1) for the root node
- * - The dqt_barrier_t is the global barrier descriptor, allocated in the reference
- *   process cluster as an extension of the generic barrier descriptor. It contains a
- *   3D array of extended pointers on all DQT nodes implementing the DQT barrier.
- * - The dqt_node_t is a local barrier implementing a togle barrier between all threads
- *   of a given cluster (for a terminal node), or between all representatives of the four
- *   children nodes (for a non terminal node).
- ****************************************************************************************/
-
-#define  DQT_XMAX    16               // max number of clusters in a row
-#define  DQT_YMAX    16               // max number of clusters in a column
-#define  DQT_LMAX    5                // max depth of the quad tree
-
-typedef struct dqt_node_s
-{
-    remote_busylock_t  lock;          /*! lock protecting list of waiting threads       */
-    volatile uint32_t  sense;         /*! barrier state (toggle)                        */
-    volatile uint32_t  current;       /*! number of locally arrived threads             */
-    uint32_t           arity;         /*! total number of locally expected threads      */
-    uint32_t           level;         /*! hierarchical level (0 is bottom)              */
-    xptr_t             parent_xp;     /*! x_pointer on parent node (NULL for root)      */
-    xptr_t             child_xp[4];   /*! x_pointer on children node (NULL for bottom)  */
-    xlist_entry_t      root;          /*! root of list of waiting threads               */
-}
-dqt_node_t;
-
-typedef struct dqt_barrier_s
-{
-    xptr_t    node_xp[DQT_XMAX][DQT_YMAX][DQT_LMAX];  /*! array of xptr on DQT nodes    */
-
-    uint32_t  x_size;                 /*! number of clusters in one row of DQT mesh     */
-    uint32_t  y_size;                 /*! number of clusters in one column of DQT mesh  */
-    uint32_t  nthreads;               /*! number of expected threads in one cluster     */
-} 
-dqt_barrier_t;
-
-/*****************************************************************************************
- * This function allocates memory for the DQT barrier descriptor in the reference cluster
- * of the calling process. It allocates also memory in all clusters of the QDT mesh, 
- * to store up to 5 QDT nodes per cluster. 
- * It initializes the barrier descriptor, including initialisation of the parent/children
- * extended pointers in the distributed QDT nodes.
- * It returns a local pointer on the QDT barrier descriptor in reference cluster.
- * It can be called by a thread running in any cluster, as it use RPCs for memory
- * allocation, and remote access for QDT initialisation.
- *****************************************************************************************
- * @ x_size      : [in] number of clusters in a line of DQT mesh.
- * @ y_size      : [in] number of clusters in a column of DQT mesh.
- * @ nthreads    : [in] number of threads per cluster.
- * @ return Local pointer on barrier descriptor if success / return NULL if failure.
- ****************************************************************************************/
-dqt_barrier_t * dqt_barrier_create( uint32_t  x_size,
-                                    uint32_t  y_size,
-                                    uint32_t  nthreads );
-
-/*****************************************************************************************
- * This function releases all memory allocated for the QDT barrier descriptor.
- * It removes the barrier from the list of barriers rooted in the reference process.
- * It can be called by a thread running in any cluster, as it use RPCs.
- *****************************************************************************************
- * @ barrier_xp  : extended pointer on DQT barrier descriptor.
- ****************************************************************************************/
-void dqt_barrier_destroy( xptr_t   barrier_xp );
-
-/*****************************************************************************************
- * This blocking function returns only when all expected threads reach the barrier.
- * It can be called by a thread running in any cluster, as it use remote accesses.
- * Waiting threads use a descheduling policy.
- *****************************************************************************************
- * @ barrier_xp   : extended pointer on DQT barrier descriptor.
- ****************************************************************************************/
-void dqt_barrier_wait( xptr_t   barrier_xp );
-
-/*****************************************************************************************
- * This debug function uses remote accesses to display the current state of all 
- * ditributed nodes in a DQT barrier identified by the <barrier_xp> argument.
- * It can be called by a thread running in any cluster.
- *****************************************************************************************
- * @ barrier_xp   : extended pointer on DQT barrier descriptor.
- ****************************************************************************************/
-void dqt_barrier_display( xptr_t barrier_xp );
-
 #endif	/* _REMOTE_BARRIER_H_ */
Index: trunk/kernel/libk/remote_fifo.c
===================================================================
--- trunk/kernel/libk/remote_fifo.c	(revision 690)
+++ trunk/kernel/libk/remote_fifo.c	(revision 1)
@@ -1,7 +1,8 @@
 /*
- * remote_fifo.c  Implement a lock-less FIFO, multiple-remote-writers / single-local-reader
+ * remote_fifo.c  Implement a lock-less FIFO,
+                  multiple-remote-writers / single-local-reader
  *
  * Authors : Mohamed Lamine Karaoui (2015)
- *           Alain Greiner          (2016,2017)
+ *           Alain Greiner          (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -23,5 +24,5 @@
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <hal_irqmask.h>
 #include <hal_remote.h>
@@ -34,21 +35,22 @@
 #include <remote_fifo.h>
 
-/////////////////////////////////////////////
-void remote_fifo_init( remote_fifo_t * fifo )
+////////////////////////////////////////////
+void local_fifo_init( remote_fifo_t * fifo )
 {
     uint32_t  slot;
 
-    fifo->owner     = 0;
 	fifo->wr_id     = 0;
 	fifo->rd_id     = 0;
-    for( slot = 0 ; slot < CONFIG_RPC_FIFO_SLOTS ; slot++ )
+    for( slot = 0 ; slot < CONFIG_REMOTE_FIFO_SLOTS ; slot++ )
     {
-        fifo->valid[slot] = 0;
+        fifo->valid[slot] = false;
     }
 }
 
-/////////////////////////////////////////////////
-error_t remote_fifo_put_item( xptr_t     fifo_xp, 
-                              uint64_t   item )
+//////////////////////////////////////////// 
+error_t remote_fifo_put_item( xptr_t   fifo, 
+                              void   * item,
+                              uint32_t size,
+                              bool_t * first )
 {
     uint32_t        wr_id;
@@ -56,26 +58,35 @@
     uint32_t        ptw;
     uint32_t        watchdog;
+    uint32_t        save_sr;
     uint32_t        nslots;
 
     // get remote cluster identifier and pointer on FIFO
-    cxy_t           fifo_cxy = GET_CXY( fifo_xp );
-    remote_fifo_t * fifo_ptr = GET_PTR( fifo_xp );
+    cxy_t           cxy = (cxy_t)GET_CXY( fifo );
+    remote_fifo_t * ptr = (remote_fifo_t *)GET_PTR( fifo );
 
     // initialise watchdog for contention detection
     watchdog = 0;
 
-    // get write slot index with atomic increment QQQQQQQQQQ
-	wr_id = hal_remote_atomic_add( XPTR( fifo_cxy , &fifo_ptr->wr_id ) , 1 );
-
-    // wait until allocated slot is empty in remote FIFO
-    // max retry = CONFIG_RPC_FIFO_MAX_ITERATIONS  
-    // return error if watchdog is reached
+    // no descheduling during put access
+	hal_disable_irq( &save_sr );
+	
+    // get write slot index and increment 
+	wr_id = hal_remote_atomic_add( XPTR( cxy , &ptr->wr_id ) , 1 );
+
+    // check fifo state
     while( 1 )
     {
         // return error if contention detected by watchdog
-        if( watchdog > CONFIG_RPC_FIFO_MAX_ITERATIONS )  return EBUSY;
+        if( watchdog > CONFIG_REMOTE_FIFO_MAX_ITERATIONS ) 
+        {
+            // restore scheduling
+	        hal_restore_irq( save_sr );
+
+            // return error
+            return EBUSY;
+        }
 
         // read remote rd_id value
-        rd_id = hal_remote_l32( XPTR( fifo_cxy , &fifo_ptr->rd_id ) );
+        rd_id = hal_remote_lw( XPTR( cxy , &ptr->rd_id ) );
 
         // compute number of full slots
@@ -83,12 +94,15 @@
         else                 nslots = (0xFFFFFFFF - rd_id) + wr_id;
 
-        // exit waiting loop as soon as fifo not full
-        if ( nslots < CONFIG_RPC_FIFO_SLOTS )  break;
+        // exit if fifo not full
+        if ( nslots < CONFIG_REMOTE_FIFO_SLOTS )  break;
         
-        // retry later if fifo full:
-        // - deschedule without blocking if possible
-        // - wait ~1000 cycles otherwise
-        if( CURRENT_THREAD->busylocks == 0 ) sched_yield( "wait RPC fifo" );
-        else                                 hal_fixed_delay( 1000 );
+        // restore interrupts
+	    hal_restore_irq( save_sr );
+
+        // deschedule without blocking 
+        if( thread_can_yield() ) sched_yield();
+
+        // disable interrupts
+	    hal_disable_irq( &save_sr );
 
         // increment watchdog
@@ -97,13 +111,21 @@
 
     // compute actual write slot pointer
-    ptw = wr_id % CONFIG_RPC_FIFO_SLOTS;
+    ptw = wr_id % CONFIG_REMOTE_FIFO_SLOTS;
 
     // copy item to fifo
-	hal_remote_s64( XPTR( fifo_cxy , &fifo_ptr->data[ptw] ), item );
-	hal_fence();
+	hal_remote_memcpy( XPTR( cxy       , &ptr->data[ptw] ),
+                       XPTR( local_cxy , item ) , size ); 
+	hal_wbflush();
 
     // set the slot valid flag
-	hal_remote_s32( XPTR( fifo_cxy , &fifo_ptr->valid[ptw] ) , 1 );
-	hal_fence();
+	hal_remote_sw( XPTR( cxy , &ptr->valid[ptw] ) , 1 );
+
+	hal_wbflush();
+
+    // return the first RPC flag
+    *first = ( wr_id == rd_id );
+    
+    // restore scheduling
+	hal_restore_irq( save_sr );
 
     return 0;
@@ -111,7 +133,8 @@
 } // end remote_fifo_put_item()
 
-///////////////////////////////////////////////////
-error_t remote_fifo_get_item( remote_fifo_t * fifo,
-                              uint64_t      * item )
+//////////////////////////////////////////////////
+error_t local_fifo_get_item( remote_fifo_t * fifo,
+                             void          * item, 
+                             uint32_t        size )
 {
     // get fifo state
@@ -123,5 +146,5 @@
 	
     // compute actual read slot pointer 
-	uint32_t ptr = rd_id % CONFIG_RPC_FIFO_SLOTS;
+	uint32_t ptr = rd_id % CONFIG_REMOTE_FIFO_SLOTS;
 	
 	// wait slot filled by the writer
@@ -129,5 +152,5 @@
 	
     // copy item from FIFO to local buffer
-    *item = fifo->data[ptr];
+    memcpy( item , &fifo->data[ptr] , size );
 
     // reset valid slot flag
@@ -138,6 +161,5 @@
 
 	return 0;
-
-} // end remote_fifo_get_item()
+} // end local_fifo_get_item()
 
 /////////////////////////////////////////
@@ -147,10 +169,10 @@
 
     // get remote cluster identifier and pointer on FIFO
-    cxy_t           cxy = GET_CXY( fifo );
-    remote_fifo_t * ptr = GET_PTR( fifo );
+    cxy_t           cxy = (cxy_t)GET_CXY( fifo );
+    remote_fifo_t * ptr = (remote_fifo_t *)GET_PTR( fifo );
    
     // get read and write pointers
-	uint32_t wr_id = hal_remote_l32( XPTR( cxy , &ptr->wr_id ) );
-	uint32_t rd_id = hal_remote_l32( XPTR( cxy , &ptr->rd_id ) );
+	uint32_t wr_id = hal_remote_lw( XPTR( cxy , &ptr->wr_id ) );
+	uint32_t rd_id = hal_remote_lw( XPTR( cxy , &ptr->rd_id ) );
 
     // compute number of full slots
@@ -158,9 +180,9 @@
     else                 nslots = (0xFFFFFFFF - rd_id) + wr_id;
 
-    return ( nslots >= CONFIG_RPC_FIFO_SLOTS );
-}
-
-///////////////////////////////////////////////////
-bool_t remote_fifo_is_empty( remote_fifo_t * fifo )
+    return ( nslots >= CONFIG_REMOTE_FIFO_SLOTS );
+}
+
+//////////////////////////////////////////////////
+bool_t local_fifo_is_empty( remote_fifo_t * fifo )
 {
     return ( fifo->wr_id == fifo->rd_id );
@@ -173,10 +195,10 @@
 
     // get remote cluster identifier and pointer on FIFO
-    cxy_t           cxy = GET_CXY( fifo );
-    remote_fifo_t * ptr = GET_PTR( fifo );
+    cxy_t           cxy = (cxy_t)GET_CXY( fifo );
+    remote_fifo_t * ptr = (remote_fifo_t *)GET_PTR( fifo );
    
     // get read and write pointers
-	uint32_t wr_id = hal_remote_l32( XPTR( cxy , &ptr->wr_id ) );
-	uint32_t rd_id = hal_remote_l32( XPTR( cxy , &ptr->rd_id ) );
+	uint32_t wr_id = hal_remote_lw( XPTR( cxy , &ptr->wr_id ) );
+	uint32_t rd_id = hal_remote_lw( XPTR( cxy , &ptr->rd_id ) );
 
     // compute number of full slots
